<?php
require_once 'vendor/autoload.php';
require_once 'includes/config.php';
require_once 'includes/functions.php';

include_once 'header.php';
?>
<div class="row">
    <div class="col">
        <h1 class="h2 text-center mt-4 mb-3">Terms of Service</h1>
        <p>Please review these terms and conditions of use carefully before using <?php echo $sitename; ?> </p>
        <p>
            This document states the terms and conditions ("Terms") upon which <?php echo $sitename; ?> ("we" or "us") will provide service to you on its websites, including, without limitation, the above listed websites (collectively, the "Website"). These Terms constitute a contractual agreement between you and us. By visiting, accessing, using, and/or joining (collectively "using") the Website, you express your understanding and acceptance of these Terms. As used in this document, the terms "you" or "your" refers to you, any entity you represent, your or its representatives, successors, assigns and affiliates, and any of your or their devices. If you do not agree to be bound by these Terms, navigate away from the Website and cease using it.
        </p>

        <h2 class="h5">1. Eligibility</h2>
        <p>
            a.) You must be at least eighteen (18) years of age to use the Website, unless the age of majority in your jurisdiction is greater than eighteen (18) years of age, in which case you must be at least the age of majority in your jurisdiction. Use of the Website is not permitted where prohibited by law.
        </p>
        <p>
            b.) The consideration for your acceptance of these Terms is that we are providing you the Grant of Use to use the Website pursuant to Section 2 hereof. You acknowledge and agree that this consideration is adequate and that you have received the consideration.
        </p>

        <h2 class="h5">2. Grant of Use</h2>
        <p>
            a.) We grant you a non-exclusive, non-transferable and limited right to access, non-publicly display, and use the Website, including all content available therein (the "Content") (subject to the restrictions of the Website) on your computer or mobile device consistent with these Terms. You may only access and use the Website for your personal and noncommercial use.
        </p>
        <p>
            b.) This grant is terminable by us at will for any reason and at our sole discretion, with or without prior notice. Upon termination, we may, but shall not be obligated to: (i) delete or deactivate your account, (ii) block your e-mail and/or IP addresses or otherwise terminate your use of and ability to use the Website, and/or (iii) remove and/or delete any of your User Submissions (defined below). You agree not to use or attempt to use the Website after said termination. Upon termination, the grant of your right to use the Website shall terminate, but all other portions of these Terms shall survive. You acknowledge that we are not responsible to you or any third party for the termination of your grant of use.
        </p>

        <h2 class="h5">3. Intellectual Property</h2>
        <p>
            Except as otherwise explicitly permitted, you agree not to copy, modify, publish, transmit, distribute, participate in the transfer or sale of, create derivative works of, or in any other way exploit, in whole or in part, any Content.
        </p>

        <h2 class="h5">4. Content on the Website</h2>
        <p>
            a.) You understand and acknowledge that, when using the Website, you will be exposed to content from a variety of sources including content made available on the Website by other users, services, parties and through automated or other means (collectively, "Third Party Content") and that we do not control and are not responsible for any Third Party Content. You understand and acknowledge that you may be exposed to content that is inaccurate, offensive, indecent or otherwise objectionable or may cause harm to your computer systems and, without limiting the other limitation of liability provisions herein, you agree to waive, and hereby do waive, any legal or equitable rights or remedies you may have against us with respect thereto.
        </p>
        <p>
            b.) We claim no ownership or control over Third Party Content. Third parties retain all rights to Third Party Content and they are responsible for protecting their rights as appropriate.
        </p>
        <p>
            c.) You understand and acknowledge that we assume no responsibility whatsoever for monitoring the Website for inappropriate content or conduct. If at any time we choose, in our sole discretion, to monitor such content, we assume no responsibility for such content, have no obligation to modify or remove any such content (including User Submissions and Third Party Content), and assume no responsibility for the conduct of others submitting any such content (including User Submissions and Third Party Content).
        </p>
        <p>
            d.) Without limiting the provisions below on limitations of liability and disclaimers of warranties, all Content (including User Submissions and Third Party Content) on the Website is provided to you "AS-IS" for your information and personal use only and you shall not use, copy, reproduce, distribute, transmit, broadcast, display, sell, license or otherwise exploit for any other purpose whatsoever the Content without the prior written consent of the respective owners/licensors of the Content.
        </p>
        <p>
            e.) You acknowledge that we may at our sole discretion refuse to publish, remove, or block access to any Content for any reason, or for no reason at all, with or without notice.
        </p>

        <h2 class="h5">5. User Conduct</h2>
        <p>
            a.) You represent and warrant that all the information and content provided by you to us is accurate and current and that you have all necessary rights, power and authority to (i) agree to these Terms, (ii) provide the User Submissions to us, and (iii) perform the acts required of you under these Terms.
        </p>
        <p>
            b.) As a condition of your use of the Website:
        </p>
        <ol>
            <li>
                You agree not to use the Website for any unlawful purpose or in any way that is prohibited by these Terms, and accept not to download any Copyright content without permission from the rightful owners;
            </li>
            <li>
                You agree to abide by all applicable local, state, national and international laws and regulations;
            </li>
            <li>
                You agree not to use the Website in any way that exposes us to criminal or civil liability;
            </li>
            <li>
                You agree that you are solely responsible for all acts and omissions that occur as a result of your use of the Website;
            </li>
            <li>
                You agree not to forge headers or otherwise manipulate identifiers in order to disguise the origin of any information you transmit;
            </li>
            <li>
                You agree not to use any automated means, including robots, crawlers or data mining tools, to download, monitor or use data or Content from the Website;
            </li>
            <li>
                You agree not to take any action that imposes, or may impose, in our sole discretion, an unreasonable or disproportionately large load on our technology infrastructure or otherwise make excessive demands on it;
            </li>
            <li>
                You agree not to "stalk" or otherwise harass anyone on or through the Website;
            </li>
            <li>
                You agree not to disable, circumvent, or otherwise interfere with security related features of the Website or features that prevent or restrict use or copying of any content or which enforce limitations on the use of the Website or the content therein;
            </li>
            <li>
                You agree not to post, link to, or otherwise make available on the Website any material that contains software viruses or any computer code, file or program designed to interrupt, destroy, limit or monitor the functionality of any computer software or hardware or any telecommunications equipment;
            </li>
            <li>
                You agree not to license, sublicense, sell, resell, transfer, assign, distribute or otherwise in any way commercially exploit or make available the Website or any Content to any third party;
            </li>
            <li>
                You agree not to "frame" or "mirror" the Website Generator; and
            </li>
            <li>
                You agree not to reverse engineer any portion of the Website.
            </li>
        </ol>
        <p></p>
        <p>
            c.) We reserve the right to take appropriate action against any user for any unauthorized use of the Website, including civil, criminal and injunctive redress and the termination of any user's use of the Website. Any use of the Website and our computer systems not authorized by these Terms is a violation of these Terms and certain international, foreign and domestic criminal and civil laws.
        </p>
        <p>
            d.) In addition to termination of the grant of use of the Website, any violation of this Agreement, including the provisions of this Section 5, shall subject you to liquidated damages of ten thousand dollars ($10,000) for each violation. In the event that your violation results in legal action (whether against you or against us by any party) or physical or emotional harm to any party, you shall be subject to liquidated damages of One Hundred and Fifty Thousand Dollars ($150,000) for each violation. We may, in our discretion, assign any such damage claim or portion thereof to a third party that has been wronged by your conduct. These liquidated damages provisions are not a penalty, but instead an attempt by the Parties to reasonably ascertain the amount of actual damage that could occur from such a violation. You acknowledge and agree that the amount of these liquidated damages is a minimum and that if actual damages are greater you shall be liable for the greater amount. If a court of competent jurisdiction finds that these liquidated damages are unenforceable to any extent, then the liquidated damages shall be lowered only by the extent necessary for them to be enforceable.
        </p>

        <h2 class="h5">6. Services on the Website</h2>
        <p>
            a.) You acknowledge that the Website is a general-purpose search engine and tool. Specifically, but without limitation, the Website allows you to search multiple websites for videos. Moreover, the Website is a general-purpose tool that allows you to download video files from the Internet. The Website may only be used in accordance with law. We do not encourage, condone, induce or allow any use of the Website that may be in violation of any law, including the download of any copyright videos and content.
        </p>

        <h2 class="h5">7. Fees</h2>
        <p>
            a.) You acknowledge that we reserve the right to charge for any or all of our services and to change our fees from time to time in our sole discretion. If at any time we terminate your rights to use the Website because of a breach of these Terms, you shall not be entitled to a refund of any portion of your fees. In all other respects, such fees shall be governed by additional rules, terms, conditions or agreements posted on the Website and/or imposed by any sales agent or payment processing company, as may be amended from time to time.
        </p>

        <h2 class="h5">8. Copyright Claims</h2>
        <p>
            a.) We respect the intellectual property rights of others. You may not infringe the copyright, trademark or other proprietary informational rights of any party. We may in our sole discretion remove any Content we have reason to believe violates any of the intellectual property rights of others and may terminate your use of the Website if you download or submit any such Content.
        </p>
        <p>
            b.) Although we are not subject to United States law, we voluntarily comply with the Digital Millennium Copyright Act. Pursuant to Title 17, Section 512(c)(2) of the United States Code, if you believe that any of your copyrighted material is being infringed on the Website, we have designated an agent to receive notifications of claimed copyright infringement. Notifications should be e-mailed to <span class="text-danger"><a href="javascript:void(0)" data-tooltip="true" title="Click Here" onclick="window.open('mailto:admin@<?php echo parse_url(BASE_URL, PHP_URL_HOST) ?>', '_blank')">[email&nbsp;protected]</a></span>.
        </p>

        <h2 class="h5">9. Modification of These Terms</h2>
        <p>
            a.) We reserve the right to amend these Terms at any time by posting such amended Terms to the Website. No other notification may be made to you about any amendments. YOU ACKNOWLEDGE THAT YOUR CONTINUED USE OF THE WEBSITE FOLLOWING SUCH AMENDMENTS WILL CONSTITUTE YOUR ACCEPTANCE OF SUCH AMENDMENTS, REGARDLESS OF WHETHER YOU HAVE ACTUALLY READ THEM.
        </p>

        <h2 class="h5">10. Indemnification and Release</h2>
        <p>
            a.) You hereby agree to indemnify us and hold us harmless from any and all damages and third-party claims and expenses, including attorney's fees, arising from your use of the Website and/or from your breach of these Terms.
        </p>
        <p>
            b.) In the event that you have a dispute with one of more other users or any third parties, you hereby release us, our officers, employees, agents and successors-in-right from claims, demands and damages (actual and consequential) of every kind or nature, known and unknown, suspected and unsuspected, disclosed and undisclosed, arising out of or in any way related to such disputes and/or the Website.
        </p>

        <h2 class="h5">11. Disclaimer of Warranties and Limitations of Liabilities</h2>
        <p>
            a.) READ THIS SECTION CAREFULLY AS IT LIMITS OUR LIABILITY TO THE MAXIMUM EXTENT PERMITTED UNDER APPLICABLE LAW (BUT NO FURTHER).
        </p>
        <p>
            b.) The Website may contain links to third-party websites which are independent of us. We assume no responsibility for the content, privacy policies, or practices of and make no representation or warranty as to the accuracy, completeness or authenticity of information contained in any third party websites. We have no right or ability to edit the content of any third party websites. You acknowledge that we shall not be liable for any and all liability arising from your use of any third party websites.
        </p>
        <p>
            c.) The Website is provided "AS-IS" and without any warranty or condition, express, implied or statutory. We specifically disclaim to the fullest extent any implied warranties of merchantability, fitness for a particular purpose, non-infringement, information accuracy, integration, interoperability or quiet enjoyment. We disclaim any warranties for viruses or other harmful components in connection with the Websites. Some jurisdictions do not allow the disclaimer of implied warranties, therefore in such jurisdictions, some of the foregoing disclaimers may not apply to you or be limited insofar as they relate to such implied warranties.
        </p>
        <p>
            d.) UNDER NO CIRCUMSTANCES SHALL WE BE LIABLE FOR DIRECT, INDIRECT INCIDENTAL, SPECIAL, CONSEQUENTIAL OR EXEMPLARY DAMAGES (EVEN IF WE HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES) RESULTING FROM ANY ASPECT OF YOUR USE OF THE WEBSITE, WHETHER, WITHOUT LIMITATION, SUCH DAMAGES ARISE FROM (i) YOUR USE, MISUSE OR INABILITY TO USE THE WEBSITE, (ii) YOUR RELIANCE ON ANY CONTENT ON THE WEBSITE, (iii) THE INTERRUPTION, SUSPENSION, MODIFICATION, ALTERATION OR COMPLETE DISCONTINUANCE OF THE WEBSITE OR (iv) THE TERMINATION OF SERVICE BY US. THESE LIMITATIONS ALSO APPLY WITH RESPECT TO DAMAGES INCURRED BY REASON OF OTHER SERVICES OR PRODUCTS RECEIVED OR ADVERTISED IN CONNECTION WITH THE WEBSITE. SOME JURISDICTIONS DO NOT ALLOW SOME LIMITATIONS OF LIABILITY, THEREFORE, IN SUCH JURISDICTIONS, SOME OF THE FOREGOING LIMITATIONS MAY NOT APPLY TO YOU OR BE LIMITED.
        </p>
        <p>
            e.) WE DO NOT WARRANT THAT (i) THE WEBSITE WILL MEET YOUR REQUIREMENTS OR EXPECTATIONS, (ii) THE WEBSITE WILL BE UNINTERRUPTED, TIMELY, SECURE, OR ERROR-FREE, (iii) THE RESULTS THAT MAY BE OBTAINED FROM YOUR USE OF THE WEBSITE WILL BE ACCURATE OR RELIABLE, (iv) THE QUALITY OF ANY PRODUCTS, SERVICES, INFORMATION, CONTENT OR OTHER MATERIAL OBTAINED THROUGH THE WEBSITE WILL MEET YOUR REQUIREMENTS OR EXPECTATIONS, OR (v) ANY ERRORS IN CONTENT WILL BE CORRECTED.
        </p>
        <p>
            f.) ANY CONTENT OBTAINED THROUGH THE USE OF THE WEBSITE IS OBTAINED AT YOUR OWN DISCRETION AND RISK. YOU ARE SOLELY RESPONSIBLE FOR ANY DAMAGE TO YOUR COMPUTER SYSTEM OR OTHER DEVICE OR LOSS OF DATA THAT RESULTS FROM SUCH CONTENT.
        </p>
        <p>
            g.) YOUR SOLE AND EXCLUSIVE RIGHT AND REMEDY IN CASE OF DISSATISFACTION WITH THE WEBSITE OR ANY OTHER GRIEVANCE SHALL BE THE TERMINATION OF YOUR USE OF THE WEBSITE. WITHOUT LIMITING THE FOREGOING, IN NO CASE SHALL THE MAXIMUM LIABILITY OF US ARISING FROM OR RELATING TO YOUR USE OF THE WEBSITES EXCEED $100.
        </p>

        <h2 class="h5">12. Legal Disputes</h2>
        <p>
            a.) To the maximum extent permitted by law, these Terms as well as any claim, cause of action, or dispute that may arise between you and us, are governed by the laws of Anguilla without regard to conflict of law provisions. FOR ANY CLAIM BROUGHT BY YOU AGAINST US, YOU AGREE TO SUBMIT AND CONSENT TO THE PERSONAL AND EXCLUSIVE JURISDICTION IN, AND THE EXCLUSIVE VENUE OF THE COURTS IN ANGUILLA. FOR ANY CLAIM BROUGHT BY US AGAINST YOU, YOU AGREE TO SUBMIT AND CONSENT TO PERSONAL JURISDICTION IN AND THE VENUE OF THE COURTS IN ANGUILLA AND ANYWHERE ELSE YOU CAN BE FOUND. You hereby waive any right to seek another venue because of improper or inconvenient forum.
        </p>
        <p>
            b.) YOU AGREE THAT YOU MAY BRING CLAIMS ONLY IN YOUR INDIVIDUAL CAPACITY AND NOT AS A PLAINTIFF OR CLASS MEMBER IN ANY PURPORTED CLASS OR REPRESENTATIVE ACTION.
        </p>
        <p>
            c.) You hereby agree that as part of the consideration for these terms, you are hereby waiving any right you may have to a trial by jury for any dispute between the us arising from or relating to these terms or the Website. This provision shall be enforceable even in the case that any arbitration provisions or any other provisions of this section are waived.
        </p>

        <h2 class="h5">13. General Terms</h2>
        <p>
            a.) These Terms, as amended from time to time, constitute the entire agreement between you and us and supersede all prior agreements between you and us and may not be modified without our written consent.
        </p>
        <p>
            b.) Our failure to enforce any provision of these Terms will not be construed as a waiver of any provision or right.
        </p>
        <p>
            c.) If any part of these Terms is determined to be invalid or unenforceable pursuant to applicable law, then the invalid and unenforceable provision will be deemed superseded by a valid, enforceable provision that most closely matches the intent of the original provision and the remainder of the agreement shall continue in effect.
        </p>
        <p>
            d.) Nothing herein is intended, nor will be deemed, to confer rights or remedies upon any third party.
        </p>
        <p>
            e.) These Terms are not assignable, transferable or sub-licensable by you except with our prior written consent, but may be assigned or transferred by us without restriction.
        </p>
        <p>
            f.) You agree that we may provide you with notices by e-mail, regular mail, or postings to the Website.
        </p>
        <p>
            g.) The section titles in these Terms are for convenience only and have no legal or contractual effect.
        </p>
        <p>
            h.) As used in these Terms, the term "including" is illustrative and not limitative.
        </p>
        <p>
            i.) If this agreement is translated and executed in any language other than English and there is any conflict as between the translation and the English version, the English version shall control.
        </p>
    </div>
</div>
<?php
include_once 'footer.php';
